<?php
//t52-t65
define('API_URL',  'https://www.googleapis.com/youtube/v3');
define('API_KEY',  'AIzaSyAFCx-xskqLXpbMpQ0DrVPQ4bRY0rq_qlk');
class SmartConfig
{
    const VOD_MOVIE_PAGE_SUPPORTED = true;
    const VOD_FAVORITES_SUPPORTED  = true;

	public static function get_data_path() {
		static $link = null;
		if (is_null($link))
			{
				$link = DuneSystem::$properties['data_dir_path'];
						if (file_exists($link . '/data_dir_path')){
							$link = smbtree::get_folder_info ('data_dir_path');
						}
			}
		return $link;
	}
	
	public static function get_plugin_ico($ico) {
	$default_ico = array (
		'catalog_categories'		=> 'plugin_file://icons/catalog_categories.png',
		'dload_list'				=> 'plugin_file://icons/dloads.png',
		'search_screen'				=> 'plugin_file://icons/find.png',
		'vod_favorites'				=> 'plugin_file://icons/fav.png',
		'vod_history'				=> 'plugin_file://icons/history.png',
		'fs_favorites'				=> 'plugin_file://icons/favfs.png',
		'category_bg'				=> 'gui_skin://images/bg.jpg',
		'main_bg'					=> 'gui_skin://images/bg.jpg',
		'vod_list_bg'				=> 'gui_skin://images/bg.jpg',
		'season_list_bg'			=> 'gui_skin://images/bg.jpg',
		'series_list_bg'			=> 'gui_skin://images/bg.jpg',
		'one_col_bg'				=> 'gui_skin://images/bg.jpg',
		'dload_screen_bg'			=> 'gui_skin://images/bg.jpg',
		'category_sandwich_base'	=> 'gui_skin://special_icons/sandwich_base.aai',
		'sandwich_cover'			=> 'cut_icon://{name=sandwich_cover}'
	);

	$plugin_ico = HD::get_items('plugin_ico');
		if (isset($plugin_ico[$ico]))
			$link = $plugin_ico[$ico];
		else if (preg_match("|_ufav|",$ico))
			$link = "plugin_file://icons/ufav.png";
		else if (file_exists( DuneSystem::$properties['install_dir_path'] ."/icons/$ico.png"))
			$link = "plugin_file://icons/$ico.png";
		else if (file_exists(self::get_data_path() ."/icons/$ico.png"))
			$link = self::get_data_path() . "/icons/$ico.png";
		else if (isset($default_ico[$ico]))
			$link = $default_ico[$ico];
		else
			$link = 'plugin_file://icons/ytf.png';
	return $link;
	}
	public static function yt_channel_ico($channelId){
		
		$ico_path = 'plugin_file://icons/6.png';
		if (preg_match('|videoCategoryId=(\d*)|',$channelId, $match))
			$channelId = $match[1];
		$ico_array = array (0=>0,1=>4,10=>1,17=>2,18=>4,20=>3,30=>4,31=>4,23=>4,25=>5,7=>7,);
		if (isset ($ico_array[$channelId]))
			$ico_path = 'plugin_file://icons/'.$ico_array[$channelId].'.png';
		return $ico_path;
	}
	public static function get_main_menu() {
			
		$mm['catalog_categories']	= '%tr%t52';
		$mm['home_categories']		= '%tr%t53';
		$tokens = HD::get_items('tokens');
		if (isset($tokens['access_token']))
			$mm['user_categories']	= 'my YouTube';
		$user_plus_tokens = HD::get_items('user_plus_tokens');
		if (count($user_plus_tokens)> 0){
			foreach ($user_plus_tokens as $k => $v)
				$mm['user_categories_plus']	= $k;
		}
		$mm['search_screen']	= '%tr%t54';
		$mm['vod_favorites']	= '%tr%t55';
		$mm['vod_history']		= '%tr%t56';

		$main_menu_manually = HD::get_items('main_menu_manually');
		if (!empty($main_menu_manually))
			$mm = array_merge($mm, $main_menu_manually);
		$ufav_itms = HD::get_items('ufav_itms');
		if (!empty($ufav_itms))
			$mm = array_merge($mm, $ufav_itms);
		return $mm;
	}
	
	public static function get_categories_name($genre_id){
		$mm = self::get_main_menu();
		if (isset($mm[$genre_id]))
			return $mm[$genre_id];
		else
			return false;
	}
	public static function get_main_categories($category_id) {
		$ylb_api_key = Youtube::get_ylb_api_key();
		if ($category_id == 'catalog_categories'){
			$jsd = json_decode(HD::http_get_document(API_URL."/videoCategories?part=snippet&hl=".$ylb_api_key['hl']."&locale=".$ylb_api_key['hl']."&regionCode=".$ylb_api_key['cr']."&key=". API_KEY));
			$categories['%tr%t57'] = API_URL . "/videos?part=snippet&chart=mostPopular&maxResults=50&key=". API_KEY;
			foreach ($jsd->items as $v)
				if ($v->snippet->assignable == true)
					$categories[$v->snippet->title] =  API_URL . "/videos?part=snippet&chart=mostPopular&maxResults=50&videoCategoryId=".$v->id."&key=". API_KEY;
			$categories['#live broadcasts'] = API_URL."/search?eventType=live&part=snippet&type=video&maxResults=50&key=".API_KEY;
			$categories['#upcoming broadcasts'] = API_URL."/search?eventType=upcoming&part=snippet&type=video&maxResults=50&key=".API_KEY;
			$categories['#completed broadcasts'] = API_URL."/search?eventType=completed&part=snippet&type=video&maxResults=50&key=".API_KEY;
		}
		if (($category_id == 'user_categories')||($category_id == 'user_categories_plus')){
			$categories['%tr%t58']	= 'myhome_categories';
			$categories['%tr%t59'] = 'FEsubscriptions';
			$categories['%tr%t60'] = 'v3subscriptions';
			$categories['%tr%t65'] = 'FEmy_youtube';
			$categories['%tr%t62'] = 'mix_recommendation';
			$categories['%tr%t63'] = 'yt_recommendation';
			$categories['%tr%t64'] = 'MUSIC';
			$categories['%tr%t56'] = 'FEhistory';
			$categories['Rating like'] = 'like';
			$categories['Rating dislike'] = 'dislike';
			
		}
		if (($category_id == 'home_categories')||($category_id == 'myhome_categories')){
			if ($category_id == 'home_categories')
				$noLogIn = 1;
			else
				$noLogIn = false;
			$jsd = self::do_get_ylb_api('browse','default', false,false,false,false,false,false,false,false,$noLogIn);
			foreach ($jsd->header->topicsHeaderRenderer->topics as $key => $vel)
				$categories[$vel->topicRenderer->title->runs[0]->text] = urlencode(json_encode($vel->topicRenderer->navigationEndpoint->browseEndpoint));
		}
		if ($category_id == 'FEmy_youtube')
			$categories = self::get_FEmy_youtube();
		return $categories;
    }
	public static function get_catalog_categories ($cat = null){
		static $categories = null;
		static $subcategories = null;
		if ((is_null($subcategories))&&(is_null($categories))){
			$jsd =json_decode (HD::http_get_document(API_URL . "/categories?access_token=" . ACCESS_TOKEN));
			foreach ($jsd->data as $v){
				$categories[$v->name] = $v->uri;
				foreach ($v->metadata->connections as $key => $vel)
					$subcategories[$v->uri][ucfirst($key)] = $vel->uri;
				$subcategories[$v->uri] = array_reverse($subcategories[$v->uri]);
				foreach ($v->subcategories as $vel)
					$subcategories[$v->uri][$vel->name] = $vel->uri . '/videos';
			}
		}
		if ($cat == false)
			return $categories;
		else
			return $subcategories[$cat];
	}
	public static function get_yt_home($jsd){
		if ($jsd == true){
			$items = array();
			if (isset($jsd->contents->sectionListRenderer->contents))
				$forObj = $jsd->contents->sectionListRenderer->contents;
			if (isset($jsd->continuationContents->sectionListContinuation->contents))
				$forObj = $jsd->continuationContents->sectionListContinuation->contents;
			foreach ($forObj as $key => $vel){
				$img = 'plugin_file://icons/'.rand(0, 7).'.png';
				if (isset($vel->shelfRenderer->title->runs[0]->text))
					$title = $vel->shelfRenderer->title->runs[0]->text;
				else
					continue;
				$sKey = md5($key + 1 . $title);
				if (isset($vel->shelfRenderer->thumbnail->thumbnails[0]->url))
					$img = "http:" . str_replace(array("https:",'s88-'),array("",'s200-' ), $vel->shelfRenderer->thumbnail->thumbnails[0]->url);
				$info = '';
				$movie = new ShortMovie(
					strval($sKey),
					strval(HD::str_remove_tag($title)),
					strval($img)
				);
				$info .= '||' . str_replace("|", "", $title);
				if (isset($vel->shelfRenderer->titleAnnotation->runs[0]->text))
					$info .= '|' . $vel->shelfRenderer->titleAnnotation->runs[0]->text;
				else
					$info .= '|...' ;
				if (isset($vel->shelfRenderer->endpoint->browseEndpoint->browseId)){
					$movie->channelId = $vel->shelfRenderer->endpoint->browseEndpoint->browseId;
					$movie->channelTitle = HD::str_remove_tag($title);
				}
				$movie->info = $info;
				$arr = array();				
				if (isset($vel->shelfRenderer->content->horizontalListRenderer->items)){
					foreach ($vel->shelfRenderer->content->horizontalListRenderer->items as $k => $v){
						if (isset($v->gridVideoRenderer))
							$v = $v->gridVideoRenderer;
						if (isset($v->gridRadioRenderer))
							$v = $v->gridRadioRenderer;
						if (isset($v->gridPlaylistRenderer))
							$v = $v->gridPlaylistRenderer;
						if (isset($v->gridChannelRenderer))
							$v = $v->gridChannelRenderer;
						
						if (isset($v->videoId))
							$arr[$v->videoId]['videoId'] = $id = $v->videoId;
						else if (isset($v->playlistId))
							$arr[$v->playlistId]['playlistId'] = $id = $v->playlistId;
						else if (isset($v->channelId))
							$arr[$v->channelId]['channel_Id'] = $id = $v->channelId;

						if (isset($v->thumbnail->thumbnails[1]->url))
							$arr[$id]['thumbnail'] = 'http:' . str_replace("https:", "",$v->thumbnail->thumbnails[1]->url);
						if (isset($v->thumbnailRenderer->playlistCustomThumbnailRenderer->thumbnail->thumbnails[1]->url))
							$arr[$id]['thumbnail'] = DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . urlencode ($v->thumbnailRenderer->playlistCustomThumbnailRenderer->thumbnail->thumbnails[0]->url);
						if (isset($v->thumbnailRenderer->playlistVideoThumbnailRenderer->thumbnail->thumbnails[1]->url))
							$arr[$id]['thumbnail'] = 'http:' . str_replace("https:", "",$v->thumbnailRenderer->playlistVideoThumbnailRenderer->thumbnail->thumbnails[1]->url);
						if (isset($v->title->runs[0]->text))
							$arr[$id]['title'] = $v->title->runs[0]->text;
						if (isset($v->viewCountText->runs[0]->text))
							$arr[$id]['viewCountText'] = $v->viewCountText->runs[0]->text;
						if (isset($v->lengthText->runs[0]->text))
							$arr[$id]['lengthText'] = $v->lengthText->runs[0]->text;
						if (isset($v->videoCountText->runs[0]->text))
							$arr[$id]['videoCountText'] = $v->videoCountText->runs[0]->text;
						if (isset($v->shortBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId))
							$arr[$id]['channelId'] = $v->shortBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId;
						if (isset($v->shortBylineText->runs[0]->text))
							$arr[$id]['channelTitle'] = $v->shortBylineText->runs[0]->text;
						if (isset($v->longBylineText->runs[0]->text))
							$arr[$id]['longBylineText'] = $v->longBylineText->runs[0]->text;
						if (isset($v->badges[0]->textBadge->label->runs[0]->text))
							$arr[$id]['badges'] = $v->badges[0]->textBadge->label->runs[0]->text;
						if (isset($v->publishedTimeText->runs[0]->text))
							$arr[$id]['publishedTimeText'] = $v->publishedTimeText->runs[0]->text;
					}
				}
				$movie->arr = $arr;
				array_push ($items, $movie);
			}
			return $items;
		}
		hd_print('wtf?!');
		return false;
	}
	public static function get_playlists_items ($playlistId, $m_feed=null, $mArr=null){
		static $mItems = null;
		if (($mArr==true)&&(isset($mItems[$playlistId][$m_feed]))){
			return $mItems[$playlistId][$m_feed];
		}
		$items = array();
		if ($m_feed == true){
			if (preg_match('|nId_(.*)|',$m_feed, $match))
				$jsd = self::do_get_ylb_api('next', false, false, $playlistId, false, $match[1], 51);
			else
				$jsd = self::do_get_ylb_api('next',false, $m_feed);
			$feed = $m_feed;
		}else{
			$jsd = self::do_get_ylb_api('next', false, false, $playlistId);
			$feed = 'FEplaylist';
		}
		
		if (isset($jsd->contents->singleColumnWatchNextResults->pivot->pivot->contents[0]->pivotShelfRenderer->content->pivotHorizontalListRenderer->items))
			$jsdArr = $jsd->contents->singleColumnWatchNextResults->pivot->pivot->contents[0]->pivotShelfRenderer->content->pivotHorizontalListRenderer->items;
		else if (isset($jsd->continuationContents->pivotHorizontalListContinuation->items))
			$jsdArr = $jsd->continuationContents->pivotHorizontalListContinuation->items;
		
		if (($m_feed==false)&&(isset($jsd->contents->singleColumnWatchNextResults->playlist->playlist->isInfinite))&&($jsd->contents->singleColumnWatchNextResults->playlist->playlist->isInfinite == 1)){
			$jsd = self::do_get_ylb_api('next', false, false, $playlistId, false, $jsdArr[count($jsdArr) - 1]->pivotVideoRenderer->videoId, 51);
			$jsdArr = $jsd->contents->singleColumnWatchNextResults->pivot->pivot->contents[0]->pivotShelfRenderer->content->pivotHorizontalListRenderer->items;
		}
		if ((isset($jsd->contents->singleColumnWatchNextResults->playlist->playlist->isInfinite))&&($jsd->contents->singleColumnWatchNextResults->playlist->playlist->isInfinite == 1))
			$items['m_feed'] = 'nId_' . $jsdArr[count($jsdArr) - 1]->pivotVideoRenderer->videoId;
		else if (isset($jsd->contents->singleColumnWatchNextResults->pivot->pivot->contents[0]->pivotShelfRenderer->content->pivotHorizontalListRenderer->continuations[0]->nextContinuationData->continuation))
			$items['m_feed'] = $jsd->contents->singleColumnWatchNextResults->pivot->pivot->contents[0]->pivotShelfRenderer->content->pivotHorizontalListRenderer->continuations[0]->nextContinuationData->continuation;

		if (isset($items['m_feed']))
			$mItems[$playlistId][$feed]['m_feed'] = $items['m_feed'];
		foreach ($jsdArr as $k => $v){
			$v = $v->pivotVideoRenderer;
			$info = '';
			$id		= $v->videoId;
			$img	= 'http:' . $v->thumbnail->thumbnails[1]->url;
			$name	= HD::str_remove_tag($v->title->runs[0]->text);
			
			$mItems[$playlistId][$feed][$k]['id']	= $id;
			$mItems[$playlistId][$feed][$k]['img']	= $img;
			$mItems[$playlistId][$feed][$k]['name']	= $name;
			if ($mArr==true)
				continue;
			$movie = new ShortMovie(
				strval($id),
				strval($name),
				strval($img)
			);
			$movie->channelId = $v->shortBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId;
			$movie->channelTitle = HD::str_remove_tag($v->shortBylineText->runs[0]->text);
			$movie->kind = 'youtube#video';
			
			$info = '||' . str_replace("|", "", $name);
			if (isset($v->publishedTimeText->runs[0]->text))
				$info .= '|' . $v->publishedTimeText->runs[0]->text;
			if (isset($v->lengthText->runs[0]->text))
				$info .= '|' . $v->lengthText->runs[0]->text;
			if (isset($v->badges[0]->textBadge->label->runs[0]->text))
				$info .= '|' . $v->badges[0]->textBadge->label->runs[0]->text;
			if (isset($v->badges[0]->liveBadge->label->runs[0]->text)){
				$info .= '|' . $v->badges[0]->liveBadge->label->runs[0]->text;
				$q =  "|live";
			}else
				$q =  "|video";
			if (isset($v->viewCountText->runs[0]->text))
				$info .= '|' . $v->viewCountText->runs[0]->text;
			$info .= '||' .  $v->shortBylineText->runs[0]->text . $q;
			if ((!isset($items['m_feed']))||((isset($items['m_feed']))&&(!preg_match('|nId_(.*)|',$items['m_feed']))))
				$info .= ' ' . $v->playlistIndexText->runs[0]->text;
			$movie->info = $info;
			$movie->url = urlencode (json_encode(array('FEplaylistId' => $playlistId, 'FEplaylist' => $feed)));
			array_push ($items, $movie);
		}
		if ($mArr==true)
			$items = $mItems[$playlistId][$feed];
		return ($items);
	}
	public static function get_yt_recommendation($mArr=null){
		static $mItems = null;
		if ($mArr==true)
			return $mItems;
		else
			$mItems = array();
		$items = array();
		$jsd = self::do_get_ylb_api('browse', 'default');
		$i = 0;
		foreach ($jsd->contents->sectionListRenderer->contents as $key => $vel){
			if ((!isset($vel->shelfRenderer->endpoint))&&(!isset($vel->shelfRenderer->guidedHelpShelfType))){
				foreach ($vel->shelfRenderer->content->horizontalListRenderer->items as $k => $v){
					$v = $v->gridVideoRenderer;
					$info = '';
					$id		= $v->videoId;
					$img	= 'http:' . $v->thumbnail->thumbnails[1]->url;
					$name	= HD::str_remove_tag($v->title->runs[0]->text);
					
					$mItems[$i]['id']	= $id;
					$mItems[$i]['img']	= $img;
					$mItems[$i]['name']	= $name;
					$movie = new ShortMovie(
						strval($id),
						strval($name),
						strval($img)
					);
					$movie->channelTitle	= HD::str_remove_tag($v->longBylineText->runs[0]->text);
					$movie->channelId 		= $v->longBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId;
					$movie->kind 			= 'youtube#video';
					
					$info = '||' . str_replace("|", "", $name);
					if (isset($v->publishedTimeText->runs[0]->text))
						$info .= '|' . $v->publishedTimeText->runs[0]->text;
					if (isset($v->lengthText->runs[0]->text))
						$info .= '|' . $v->lengthText->runs[0]->text;
					if (isset($v->badges[0]->textBadge->label->runs[0]->text))
						$info .= '|' . $v->badges[0]->textBadge->label->runs[0]->text;
					if (isset($v->badges[0]->liveBadge->label->runs[0]->text)){
						$info .= '|' . $v->badges[0]->liveBadge->label->runs[0]->text;
						$q =  "|[live]";
					}else
						$q =  "|[video]";
					if (isset($v->viewCountText->runs[0]->text))
						$info .= '|' . $v->viewCountText->runs[0]->text;
					$info .= '||' .  $v->longBylineText->runs[0]->text . $q;
					$movie->info = $info;
					$movie->url = urlencode (json_encode(array('yt_recommendation' => 1)));
					array_push ($items, $movie);
					$i++;
				 }
			 }
		}
		return ($items);
	}
	public static function get_actions_subscriptions($action, $m_feed=null, $mArr=null, $jsdR=null, $category_id = null){
		static $mItems = null;
		$cat = 0;
		if (($mArr==true)&&(isset($mItems[$m_feed])))
			return $mItems[$m_feed];
		$items = array();
		if ($m_feed == true){
			$jsd = self::do_get_ylb_api('browse',false, $m_feed);
			$feed = $m_feed;
		}else if ($jsdR == true){
			$jsd = $jsdR;
			$feed = $action;
			$cat = $category_id;
		}else{
			$jsd = self::do_get_ylb_api('browse',$action);
			$feed = $action;
		}
		if (isset($jsd->contents->sectionListRenderer->contents[$cat]->shelfRenderer->content->horizontalListRenderer->continuations[0]->nextContinuationData->continuation))
			$items['m_feed'] = $jsd->contents->sectionListRenderer->contents[$cat]->shelfRenderer->content->horizontalListRenderer->continuations[0]->nextContinuationData->continuation;
		else if(isset($jsd->continuationContents->horizontalListContinuation->continuations[$cat]->nextContinuationData->continuation))
			$items['m_feed'] = $jsd->continuationContents->horizontalListContinuation->continuations[$cat]->nextContinuationData->continuation;
		
		if (isset($jsd->contents->sectionListRenderer->contents[$cat]->shelfRenderer->content->horizontalListRenderer->items))
			$jsdArr = $jsd->contents->sectionListRenderer->contents[$cat]->shelfRenderer->content->horizontalListRenderer->items;
		else if (isset($jsd->continuationContents->horizontalListContinuation->items))
			$jsdArr = $jsd->continuationContents->horizontalListContinuation->items;
		else if (isset($jsd->contents->sectionListRenderer->contents[0]->watchHistoryShelfRenderer->content->horizontalListRenderer->items))
			$jsdArr = $jsd->contents->sectionListRenderer->contents[0]->watchHistoryShelfRenderer->content->horizontalListRenderer->items;
		if (isset($items['m_feed']))
			$mItems[$feed]['m_feed'] = $items['m_feed'];
		foreach ($jsdArr as $k => $v){
			if (isset($v->gridVideoRenderer))
				$v = $v->gridVideoRenderer;
			else{
				hd_print('Err! 442');
				continue;
			}
			$info = '';
			$id		= $v->videoId;
			$img	= 'http:' . $v->thumbnail->thumbnails[1]->url;
			$name	= HD::str_remove_tag($v->title->runs[0]->text);
			
			$mItems[$feed][$k]['id']	= $id;
			$mItems[$feed][$k]['img']	= $img;
			$mItems[$feed][$k]['name']	= $name;
			if ($mArr==true)
				continue;
			$movie = new ShortMovie(
				strval($id),
				strval($name),
				strval($img)
			);
			$movie->channelId = $v->longBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId;
			$movie->channelTitle = HD::str_remove_tag($v->longBylineText->runs[0]->text);
			$movie->kind = 'youtube#video';
			
			$info = '||' . str_replace("|", "", $name);
			if (isset($v->publishedTimeText->runs[0]->text))
				$info .= '|' . $v->publishedTimeText->runs[0]->text;
			if (isset($v->lengthText->runs[0]->text))
				$info .= '|' . $v->lengthText->runs[0]->text;
			if (isset($v->badges[0]->textBadge->label->runs[0]->text))
				$info .= '|' . $v->badges[0]->textBadge->label->runs[0]->text;
			if (isset($v->badges[0]->liveBadge->label->runs[0]->text)){
				$info .= '|' . $v->badges[0]->liveBadge->label->runs[0]->text;
				$q =  "|[live]";
			}else
				$q =  "|[video]";
			if (isset($v->upcomingEventData->startTime))
				$info .= '||Start Time: ' . date ('d.m.Y H:i', ($v->upcomingEventData->startTime + HD::date_time()));
			if (isset($v->viewCountText->runs[0]->text))
				$info .= '|' . $v->viewCountText->runs[0]->text;
			$info .= '||' .  $v->longBylineText->runs[0]->text . $q;
			$movie->info = $info;
			$movie->url = urlencode (json_encode(array($action => $feed)));
			array_push ($items, $movie);
		}
		if ($mArr==true)
			$items = $mItems[$feed];
		return ($items);
	}
	
	public static function get_main_subcategories($subcategory_id, $category_id){
		if ($category_id == 'catalog_categories')
			$category_list = self::get_catalog_categories($subcategory_id);
		if ($category_id == 'MUSIC')
			$category_list = self::get_music_categories();
		return $category_list;
	}
	
	public static function get_FEmy_youtube($category_id = null){
		$jsd = self::do_get_ylb_api('browse','FEmy_youtube');
		foreach ($jsd->contents->sectionListRenderer->contents as $key => $vel)
			$category_list[$vel->shelfRenderer->title->runs[0]->text] = $key + 1;
		if ($category_id == false)
			return $category_list;
		return $jsd;
	}
	
	public static function get_channel_categories($channelId = null, $category_id = null, $m_feed = null){
		static $arr = null;
		static $items = null;
		static $chInf = null;
		if ($m_feed == true){
			$jsd = self::do_get_ylb_api('browse',false, $m_feed);
			if(isset($jsd->continuationContents->horizontalListContinuation->continuations[0]->nextContinuationData->continuation))
				$items[$m_feed]['m_feed'] = $jsd->continuationContents->horizontalListContinuation->continuations[0]->nextContinuationData->continuation;
			foreach ($jsd->continuationContents->horizontalListContinuation->items as $k => $v){
				if (isset($v->gridVideoRenderer))
					$v = $v->gridVideoRenderer;
				if (isset($v->gridRadioRenderer))
					$v = $v->gridRadioRenderer;
				if (isset($v->gridPlaylistRenderer))
					$v = $v->gridPlaylistRenderer;
				if (isset($v->gridChannelRenderer))
					$v = $v->gridChannelRenderer;

				if (isset($v->videoId)){
					$items[$m_feed][$v->videoId]['id'] = $id = $v->videoId;
					$items[$m_feed][$id]['kind'] = 'youtube#video';
				}else if (isset($v->playlistId)){
					$items[$m_feed][$v->playlistId]['id'] = $id = $v->playlistId;
					$items[$m_feed][$id]['kind'] = 'youtube#playlist';
				}else if (isset($v->channelId)){
					$items[$m_feed][$v->channelId]['id'] = $id = $v->channelId;
					$items[$m_feed][$id]['kind'] = 'youtube#channel';
				}
				if (isset($v->thumbnail->thumbnails[1]->url))
					$items[$m_feed][$id]['thumbnail'] = 'http:' . $v->thumbnail->thumbnails[1]->url;
				if (isset($v->thumbnailRenderer->playlistCustomThumbnailRenderer->thumbnail->thumbnails[1]->url))
					$items[$m_feed][$id]['thumbnail'] = DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . urlencode ($v->thumbnailRenderer->playlistCustomThumbnailRenderer->thumbnail->thumbnails[0]->url);
				if (isset($v->thumbnailRenderer->playlistVideoThumbnailRenderer->thumbnail->thumbnails[1]->url))
					$items[$m_feed][$id]['thumbnail'] = 'http:' . $v->thumbnailRenderer->playlistVideoThumbnailRenderer->thumbnail->thumbnails[1]->url;
				if (isset($v->title->runs[0]->text))
					$items[$m_feed][$id]['title'] = $v->title->runs[0]->text;						
				if (isset($v->viewCountText->runs[0]->text))
					$items[$m_feed][$id]['viewCountText'] = $v->viewCountText->runs[0]->text;
				if (isset($v->lengthText->runs[0]->text))
					$items[$m_feed][$id]['lengthText'] = $v->lengthText->runs[0]->text;
				if (isset($v->videoCountText->runs[0]->text))
					$items[$m_feed][$id]['videoCountText'] = $v->videoCountText->runs[0]->text;
				if (isset($v->shortBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId))
					$items[$m_feed][$id]['channelId'] = $v->shortBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId;
				else
					$items[$m_feed][$id]['channelId'] = $chInf['channelId'];
				if (isset($v->shortBylineText->runs[0]->text))
					$items[$m_feed][$id]['channelTitle'] = $v->shortBylineText->runs[0]->text;
				else
					$items[$m_feed][$id]['channelTitle'] = $chInf['channelTitle'];
				if (isset($v->longBylineText->runs[0]->text))
					$items[$m_feed][$id]['longBylineText'] = $v->longBylineText->runs[0]->text;
				if (isset($v->badges[0]->textBadge->label->runs[0]->text))
					$items[$m_feed][$id]['badges'] = $v->badges[0]->textBadge->label->runs[0]->text;
				if (isset($v->publishedTimeText->runs[0]->text))
					$items[$m_feed][$id]['publishedTimeText'] = $v->publishedTimeText->runs[0]->text;
			}
			return ($items[$m_feed]);
		}
		if ($channelId == true){
			$arr = array();
			$jsd = self::do_get_ylb_api('browse',$channelId);
			if (isset($jsd->header->tvChannelHeaderRenderer->trailerEndpoint->watchEndpoint->videoId))
				$category_list['Channel Trailer'] = $jsd->header->tvChannelHeaderRenderer->trailerEndpoint->watchEndpoint->videoId;
			if (isset($jsd->contents->sectionListRenderer->contents))
				foreach ($jsd->contents->sectionListRenderer->contents as $key => $vel){
					foreach($vel->shelfRenderer->content->horizontalListRenderer->items as $k => $v){
						if (isset($v->gridRadioRenderer))
							$v = $v->gridRadioRenderer;
						if (isset($v->gridPlaylistRenderer))
							$v = $v->gridPlaylistRenderer;
						if (isset($v->gridVideoRenderer))
							$v = $v->gridVideoRenderer;
						if (isset($v->gridChannelRenderer))
							$v = $v->gridChannelRenderer;
						if (isset($v->gridChannelRenderer))
							$v = $v->gridChannelRenderer;
						if (isset($v->gridChannelRenderer))
							$v = $v->gridChannelRenderer;
												
						if (isset($v->videoId)){
							$ckey = 'сhannel_video_' . ($key + 1);
							$arr[$ckey][$v->videoId]['id'] = $id = $v->videoId;
							$arr[$ckey][$id]['kind'] = 'youtube#video';
						}else if (isset($v->playlistId)){
							$ckey = 'сhannel_playlist_' . ($key + 1);
							$arr[$ckey][$v->playlistId]['id'] = $id = $v->playlistId;
							$arr[$ckey][$id]['kind'] = 'youtube#playlist';
						}else if (isset($v->channelId)){
							$ckey = 'сhannel_channel_' . ($key + 1);
							$arr[$ckey][$v->channelId]['id'] = $id = $v->channelId;
							$arr[$ckey][$id]['kind'] = 'youtube#channel';
						}
						if (isset($v->thumbnail->thumbnails[1]->url)){
							if (!preg_match('|http|', $v->thumbnail->thumbnails[1]->url))
								$arr[$ckey][$id]['thumbnail'] = 'http:' . $v->thumbnail->thumbnails[1]->url;
							else
								$arr[$ckey][$id]['thumbnail'] = str_replace("https", "http", $v->thumbnail->thumbnails[1]->url);
						}
						if (isset($v->thumbnailRenderer->playlistCustomThumbnailRenderer->thumbnail->thumbnails[1]->url))
							$arr[$ckey][$id]['thumbnail'] = DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . urlencode ($v->thumbnailRenderer->playlistCustomThumbnailRenderer->thumbnail->thumbnails[0]->url);
						if (isset($v->thumbnailRenderer->playlistVideoThumbnailRenderer->thumbnail->thumbnails[1]->url))
							$arr[$ckey][$id]['thumbnail'] = 'http:' . $v->thumbnailRenderer->playlistVideoThumbnailRenderer->thumbnail->thumbnails[1]->url;
						if (isset($v->title->runs[0]->text))
							$arr[$ckey][$id]['title'] = $v->title->runs[0]->text;
												
						if (isset($v->viewCountText->runs[0]->text))
							$arr[$ckey][$id]['viewCountText'] = $v->viewCountText->runs[0]->text;
						if (isset($v->lengthText->runs[0]->text))
							$arr[$ckey][$id]['lengthText'] = $v->lengthText->runs[0]->text;
						if (isset($v->videoCountText->runs[0]->text))
							$arr[$ckey][$id]['videoCountText'] = $v->videoCountText->runs[0]->text;
						if (isset($v->shortBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId))
							$chInf['channelId'] = $arr[$ckey][$id]['channelId'] = $v->shortBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId;
						else
							$arr[$ckey][$id]['channelId'] = $chInf['channelId'];
						if (isset($v->shortBylineText->runs[0]->text))
							$chInf['channelTitle'] = $arr[$ckey][$id]['channelTitle'] = $v->shortBylineText->runs[0]->text;
						else
							$arr[$ckey][$id]['channelTitle'] = $chInf['channelTitle'];
						if (isset($v->longBylineText->runs[0]->text))
							$arr[$ckey][$id]['longBylineText'] = $v->longBylineText->runs[0]->text;
						if (isset($v->badges[0]->textBadge->label->runs[0]->text))
							$arr[$ckey][$id]['badges'] = $v->badges[0]->textBadge->label->runs[0]->text;
						if (isset($v->publishedTimeText->runs[0]->text))
							$arr[$ckey][$id]['publishedTimeText'] = $v->publishedTimeText->runs[0]->text;
					}
					
					$category_list[$vel->shelfRenderer->title->runs[0]->text] = $ckey;
					if (isset($vel->shelfRenderer->content->horizontalListRenderer->continuations))
						$arr[$ckey]['m_feed'] = $vel->shelfRenderer->content->horizontalListRenderer->continuations[0]->nextContinuationData->continuation;
				}
		}
		if ($category_id == true)
			return $arr[$category_id];
		else
			return $category_list;
	}
	
	public static function get_music_categories($category_id = null){
		static $arr = null;
		if ((is_null($arr))||(!isset($arr[$category_id]))){
			$jsd = self::do_get_ylb_api('browse', 'default');
			foreach ($jsd->header->topicsHeaderRenderer->topics as $v){
				if ((isset($v->topicRenderer->topicStyle))&&($v->topicRenderer->topicStyle->styleName == 'MUSIC')){
					$jsd = self::do_get_ylb_api('browse', $v->topicRenderer->navigationEndpoint->browseEndpoint->browseId, false, false, false, false, false,$v->topicRenderer->navigationEndpoint->browseEndpoint->params);
					$arr1 = $jsd->contents->sectionListRenderer->contents;
					if (isset($jsd->contents->sectionListRenderer->continuations[0]->nextContinuationData->continuation)){
						$jsd = self::do_get_ylb_api('browse',false, $jsd->contents->sectionListRenderer->continuations[0]->nextContinuationData->continuation);
						$arr2 = $jsd->continuationContents->sectionListContinuation->contents;
					}
					$arr0 = array_merge_recursive ($arr1, $arr2);
					foreach ($arr0 as $key => $vel){
						$vel = $vel->shelfRenderer;
						if (isset($vel->title->runs[0]->text)){
							$ckey = $key + 1;
							$category_list[$vel->title->runs[0]->text] = $ckey;
							foreach ($vel->content->horizontalListRenderer->items as $k => $v){
								if (isset($v->gridRadioRenderer))
									$v = $v->gridRadioRenderer;
								if (isset($v->gridPlaylistRenderer))
									$v = $v->gridPlaylistRenderer;
								if (isset($v->gridVideoRenderer))
									$v = $v->gridVideoRenderer;
								
								if (isset($v->videoId)){
									$arr[$ckey][$v->videoId]['id'] = $id = $v->videoId;
									$arr[$ckey][$id]['kind'] = 'youtube#video';
								}else if (isset($v->playlistId)){
									$arr[$ckey][$v->playlistId]['id'] = $id = $v->playlistId;
									$arr[$ckey][$id]['kind'] = 'youtube#playlist';
								}
								
								if (isset($v->thumbnail->thumbnails[1]->url))
									$arr[$ckey][$id]['thumbnail'] = 'http:' . $v->thumbnail->thumbnails[1]->url;
								if (isset($v->thumbnailRenderer->playlistCustomThumbnailRenderer->thumbnail->thumbnails[1]->url))
									$arr[$ckey][$id]['thumbnail'] = DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . urlencode ($v->thumbnailRenderer->playlistCustomThumbnailRenderer->thumbnail->thumbnails[0]->url);
								if (isset($v->thumbnailRenderer->playlistVideoThumbnailRenderer->thumbnail->thumbnails[1]->url))
									$arr[$ckey][$id]['thumbnail'] = 'http:' . $v->thumbnailRenderer->playlistVideoThumbnailRenderer->thumbnail->thumbnails[1]->url;
								if (isset($v->title->runs[0]->text))
									$arr[$ckey][$id]['title'] = $v->title->runs[0]->text;
								
								if (isset($v->viewCountText->runs[0]->text))
									$arr[$ckey][$id]['viewCountText'] = $v->viewCountText->runs[0]->text;
								if (isset($v->lengthText->runs[0]->text))
									$arr[$ckey][$id]['lengthText'] = $v->lengthText->runs[0]->text;
								if (isset($v->videoCountText->runs[0]->text))
									$arr[$ckey][$id]['videoCountText'] = $v->videoCountText->runs[0]->text;
								if (isset($v->shortBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId))
									$arr[$ckey][$id]['channelId'] = $v->shortBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId;
								if (isset($v->shortBylineText->runs[0]->text))
									$arr[$ckey][$id]['channelTitle'] = $v->shortBylineText->runs[0]->text;
								else if (isset($v->longBylineText->runs[0]->text))
									$arr[$ckey][$id]['longBylineText'] = $v->longBylineText->runs[0]->text;
							}
						}
					}
				}
			}
		}
		if ($category_id == true)
			return $arr[$category_id];
		else
			return $category_list;
	}
	
	public static function getVideoList($category_id, $genre_id, &$m_feed) {
		if ($m_feed === '_end_')
			return array();
		$items = array();
		if (($genre_id == 'user_categories')||($genre_id == 'user_categories_plus')){
			if (($category_id == 'v3subscriptions')||($category_id == 'like')||($category_id == 'dislike')){
				$sort_page_settings = HD::get_items('sort_page_settings');
				$sort = isset($sort_page_settings[$genre_id][$category_id]['sorting']) ? $sort_page_settings[$genre_id][$category_id]['sorting'] : '&order=relevance';
				if ($category_id == 'v3subscriptions')
					$url = "/subscriptions?part=snippet&maxResults=50&mine=true$sort";
				else
					$url = "/videos?part=snippet&maxResults=50&myRating=$category_id";
				if ($m_feed != '0')
					$url .= "&pageToken=" . $m_feed;
				$jsd = self::http_get_api_v3($url);
				if (isset($jsd->nextPageToken))
					$m_feed = $jsd->nextPageToken;
				else
					$m_feed = '_end_';
				if (isset($jsd->error->message)){
					hd_print("-->Msg:" . $jsd->error->message);
					return array();
				}
				return self::do_shortmovie($jsd->items, $url);
			}
			if ($category_id == 'allFEsubscriptions'){
				static $FEsubscriptions_arr = null;
				if ($m_feed == 0)
					$FEsubscriptions_arr = null;
				if (is_null($FEsubscriptions_arr)){
					$jsd = self::do_get_ylb_api('browse','FEsubscriptions');
					foreach ($jsd->contents->sectionListRenderer->contents[1]->shelfRenderer->content->horizontalListRenderer->items as $k => $v){
						$v = $v->gridChannelRenderer;
						$FEsubscriptions_arr[$k]['channelId'] = $v->channelId;
						$FEsubscriptions_arr[$k]['thumbnail'] = str_replace(array("https://",'/s88-'),array("http://",'/s200-' ),$v->thumbnail->thumbnails[0]->url);
						$FEsubscriptions_arr[$k]['title'] = HD::str_remove_tag($v->title->runs[0]->text);
					}
				}
				if (($m_feed * 50) < (count($FEsubscriptions_arr))){
					$i=$m_feed * 50;
					do {
						if (isset($FEsubscriptions_arr[$i])){
							$movie = new ShortMovie(
								strval($FEsubscriptions_arr[$i]['channelId']),
								strval(HD::str_remove_tag($FEsubscriptions_arr[$i]['title'])),
								strval($FEsubscriptions_arr[$i]['thumbnail'])
							);
							$info = '||' . str_replace("|", "", $FEsubscriptions_arr[$i]['title']);
							$movie->kind = 'youtube#channel';
							$movie->info = $info;
							array_push ($items, $movie);
						}
						$i++;
					} while ($i < (($m_feed * 50) + 50));
					++$m_feed;
					return $items;
				}else
					return false;
			}
			if (($category_id == 'FEsubscriptions')||($category_id == 'FEhistory')){
				if ($m_feed == '0')
					$arr = self::get_actions_subscriptions($category_id);
				else
					$arr = self::get_actions_subscriptions($category_id, $m_feed);
				if (isset($arr['m_feed'])){
					$m_feed = $arr['m_feed'];
					unset($arr['m_feed']);
				}else
					$m_feed = '_end_';
				return $arr;
			}
			if ($category_id == 'yt_recommendation'){
				$m_feed = '_end_';
				return self::get_yt_recommendation();
			}
			if ($category_id == 'mix_recommendation'){
				$jsd = self::do_get_ylb_api('browse', 'default');
				foreach ($jsd->contents->sectionListRenderer->contents as $k => $v)
					if ((isset($jsd->contents->sectionListRenderer->contents[$k]->shelfRenderer->guidedHelpShelfType))&&($jsd->contents->sectionListRenderer->contents[$k]->shelfRenderer->guidedHelpShelfType == 'MIX_RECOMMENDATION')){
						foreach ($jsd->contents->sectionListRenderer->contents[$k]->shelfRenderer->content->horizontalListRenderer->items as $k => $v){
							$info = '';
							$v = $v->gridRadioRenderer;
							$id				= $v->playlistId;
							$img			= 'http:' . $v->thumbnail->thumbnails[1]->url;
							$name			= $v->title->runs[0]->text;
							$movie = new ShortMovie(
								strval($id),
								strval(HD::str_remove_tag($name)),
								strval($img)
							);
							$movie->kind = 'youtube#playlist';
							$info .= '||' . str_replace("|", "", $name);
							$info .= '|' . $v->shortBylineText->runs[0]->text;
							if (isset($v->longBylineText->runs[0]->text))
								$info .= '||' . $v->longBylineText->runs[0]->text;
							$info .= '|' . $v->videoCountText->runs[0]->text;
							$movie->info = $info;
							array_push ($items, $movie);
						}
						break;
					}
				$m_feed = '_end_';
				return $items;
			}
		}
		if ($genre_id == 'FEmy_youtube'){
			
			if ($m_feed == '0')
				$jsd = self::get_FEmy_youtube(1);
			else
				$jsd = self::do_get_ylb_api('browse',false, $m_feed);
			
			if (isset($jsd->contents->sectionListRenderer->contents[$category_id - 1]->shelfRenderer->content->horizontalListRenderer->items[0]->gridVideoRenderer)){
				$arr = self::get_actions_subscriptions($genre_id, false, false, $jsd, $category_id - 1);
				if (isset($arr['m_feed'])){
					$m_feed = $arr['m_feed'];
					unset($arr['m_feed']);
				}else
					$m_feed = '_end_';
				return $arr;
			}else if (isset($jsd->continuationContents->horizontalListContinuation->items[0]->gridVideoRenderer)){
				$arr = self::get_actions_subscriptions($genre_id, false, false, $jsd);
				if (isset($arr['m_feed'])){
					$m_feed = $arr['m_feed'];
					unset($arr['m_feed']);
				}else
					$m_feed = '_end_';
				return $arr;
			}else{
				if (isset($jsd->contents->sectionListRenderer->contents[$category_id - 1]->shelfRenderer->content->horizontalListRenderer->items))
					$jsdArr = $jsd->contents->sectionListRenderer->contents[$category_id - 1]->shelfRenderer->content->horizontalListRenderer->items;
				else if (isset($jsd->continuationContents->horizontalListContinuation->items))
					$jsdArr = $jsd->continuationContents->horizontalListContinuation->items;
				foreach ($jsdArr as $k => $v){
					$info = '';
					if (isset($v->gridRadioRenderer))
						$v 				= $v->gridRadioRenderer;
					if (isset($v->gridPlaylistRenderer))
						$v 				= $v->gridPlaylistRenderer;
					$id				= $v->playlistId;
					$img			= 'http:' . $v->thumbnail->thumbnails[1]->url;
					$name			= $v->title->runs[0]->text;
					$movie = new ShortMovie(
						strval($id),
						strval(HD::str_remove_tag($name)),
						strval($img)
					);
					$movie->kind = 'youtube#playlist';
					$info .= '||' . str_replace("|", "", $name);
					$info .= '|' . $v->videoCountText->runs[0]->text;
					if (isset($v->publishedTimeText->runs[0]->text))
						$info .= '|' . $v->publishedTimeText->runs[0]->text;
					$movie->info = $info;
					$movie->channelId = false;
					$movie->channelTitle = false;
					array_push ($items, $movie);
				}
				if(isset($jsd->contents->sectionListRenderer->contents[1]->shelfRenderer->content->horizontalListRenderer->continuations[0]->nextContinuationData->continuation))
					$m_feed	= $jsd->contents->sectionListRenderer->contents[1]->shelfRenderer->content->horizontalListRenderer->continuations[0]->nextContinuationData->continuation;
				else if(isset($jsd->continuationContents->horizontalListContinuation->continuations[0]->nextContinuationData->continuation))
					$m_feed	= $jsd->continuationContents->horizontalListContinuation->continuations[0]->nextContinuationData->continuation;
				else
					$m_feed = '_end_';
				return $items;
			}
				
		}
		if ($genre_id == 'MUSIC'){
			foreach (self::get_music_categories($category_id) as $v){
				$info = '';
				$movie = new ShortMovie(
					strval($v['id']),
					strval(HD::str_remove_tag($v['title'])),
					strval($v['thumbnail'])
				);
				$movie->kind = $v['kind'];
				$info .= '||' . str_replace("|", "", $v['title']);
				if (isset($v['viewCountText']))
					$info .= '|' . $v['viewCountText'];
				if (isset($v['lengthText']))
					$info .= '|' . $v['lengthText'];
				if (isset($v['videoCountText']))
					$info .= '|' . $v['videoCountText'];
				if (isset($v['channelId']))
					$movie->channelId = $v['channelId'];
				if (isset($v['channelTitle'])){
					$movie->channelTitle = HD::str_remove_tag($v['channelTitle']);
					if ($movie->kind != "youtube#channel")
						$info .= '||' . $v['channelTitle'];				
				}else if (isset($v['longBylineText']))
					$info .= '||' . $v['longBylineText'];
				$info .= '|['. str_replace("youtube#", "", $movie->kind) . '] ';
				$movie->info = $info;
				if ($movie->kind == 'youtube#video')
					$movie->url = urlencode(json_encode(array($genre_id => $category_id)));
				array_push ($items, $movie);
			}
			$m_feed = '_end_';
			return $items;
		}
		if (($genre_id == 'channel')&&(preg_match('/сhannel_/', $category_id))){
			if ($m_feed == '0'){
				$arr = self::get_channel_categories(false, $category_id);
				$url = urlencode (json_encode(array($genre_id => $category_id)));
			}else{
				$arr = self::get_channel_categories(false, false, $m_feed);
				$url = urlencode (json_encode(array($genre_id => $category_id, 'm_feed'=> $m_feed)));
			}
			if (isset($arr['m_feed'])){
				$m_feed = $arr['m_feed'];
				unset($arr['m_feed']);
			}else
				$m_feed = '_end_';
			
			foreach ($arr as $v){
				$info = '';
				$movie = new ShortMovie(
					strval($v['id']),
					strval(HD::str_remove_tag($v['title'])),
					strval($v['thumbnail'])
				);
				$movie->kind = $v['kind'];
				$info .= '||' . str_replace("|", "", $v['title']);
				if (isset($v['viewCountText']))
					$info .= '|' . $v['viewCountText'];
				if (isset($v['lengthText']))
					$info .= '|' . $v['lengthText'];
				if (isset($v['videoCountText']))
					$info .= '|' . $v['videoCountText'];
				if (isset($v['publishedTimeText']))
					$info .= '|' . $v['publishedTimeText'];
				if (isset($v['badges']))
					$info .= '|' . $v['badges'];
				if (isset($v['channelId']))
					$movie->channelId = $v['channelId'];
				if (isset($v['channelTitle'])){
					$movie->channelTitle = HD::str_remove_tag($v['channelTitle']);
					if ($movie->kind != "youtube#channel")
						$info .= '||' . $v['channelTitle'];				
				}else if (isset($v['longBylineText']))
					$info .= '||' . $v['longBylineText'];
				$info .= '|['. str_replace("youtube#", "", $movie->kind) . '] ';
				$movie->info = $info;
				if ($movie->kind == 'youtube#video')
					$movie->url = $url;
				array_push ($items, $movie);
			}
			return $items;
		}
		if (($genre_id == 'home_categories')||($genre_id == 'myhome_categories')){
			if ($genre_id == 'home_categories')
				$noLogIn = 1;
			else
				$noLogIn = false;
			if ($m_feed == '0'){
				$arg = json_decode(urldecode($category_id));
				if (isset($arg->params))
					$params = $arg->params;
				else
					$params = false;
				$jsd = self::do_get_ylb_api('browse',$arg->browseId,false,false,false,false,false,$params,false,false,$noLogIn);
			}else
				$jsd = self::do_get_ylb_api('browse',false,$m_feed,false,false,false,false,false,false,false,$noLogIn);
			if (isset($jsd->contents->sectionListRenderer->continuations[0]->nextContinuationData->continuation))
				$m_feed = $jsd->contents->sectionListRenderer->continuations[0]->nextContinuationData->continuation;
			else if (isset($jsd->continuationContents->sectionListContinuation->continuations[0]->nextContinuationData->continuation))
				$m_feed = $jsd->continuationContents->sectionListContinuation->continuations[0]->nextContinuationData->continuation;
			else
				$m_feed = '_end_';
			return self::get_yt_home($jsd);
		}
		$sort_page_settings = HD::get_items('sort_page_settings');
		$ylb_api_key = Youtube::get_ylb_api_key();
		$sort = isset($sort_page_settings[$genre_id][$category_id]['sorting']) ? $sort_page_settings[$genre_id][$category_id]['sorting'] : '&order=relevance';
		if ($genre_id == 'youtube#playlist'){
			if ($m_feed == '0')
				$arr = self::get_playlists_items($category_id);
			else
				$arr = self::get_playlists_items($category_id, $m_feed);	
			if (isset($arr['m_feed'])){
				$m_feed = $arr['m_feed'];
				unset($arr['m_feed']);
			}else
				$m_feed = '_end_';
			$playlistItems_sort = (HD::get_item('playlistItems_sort'. 
			str_replace(":", "",HD::get_mac_addr())) !='') ? HD::get_item('playlistItems_sort'. 
			str_replace(":", "",HD::get_mac_addr())) : 0;
			if ($playlistItems_sort == 1)
				$arr = array_reverse($arr);
			return $arr;
		}else
			$url = $category_id . "&hl=" . $ylb_api_key['hl']."&locale=".$ylb_api_key['hl']."&regionCode=".$ylb_api_key['cr'] . $sort;
		if ($m_feed != '0')
			$url = $url . "&pageToken=" . $m_feed;
		$jsd =json_decode (HD::http_get_document($url));
		if (isset($jsd->nextPageToken))
			$m_feed = $jsd->nextPageToken;
		else
			$m_feed = '_end_';
		if (isset($jsd->error->message)){
			hd_print("-->Msg:" . $jsd->error->message);
			return array();
		}
		return self::do_shortmovie($jsd->items, $url);
	}

	public static function do_shortmovie($catalog_items, $arg= null){
		static $check = null;
		$items = array();
		if (count($catalog_items)== 0)
			return array();
		$check = null;
		$baned_ah = HD::get_items('baned_ah');
		foreach ($catalog_items as $v){
			$info = '';
			if (isset($v->id->videoId))
				$id = $v->id->videoId;
			else if (isset($v->id->channelId))
				$id = $v->id->channelId;
			else if (isset($v->id->playlistId))
				$id = $v->id->playlistId;
			else if (isset($v->snippet->resourceId->videoId))
				$id = $v->snippet->resourceId->videoId;
			else if (isset($v->snippet->resourceId->channelId))
				$id = $v->snippet->resourceId->channelId;
			else if (isset($v->contentDetails->upload->videoId))
				$id = $v->contentDetails->upload->videoId;
			else if (isset($v->contentDetails->bulletin->resourceId->videoId))
				$id = $v->contentDetails->bulletin->resourceId->videoId;
			else
				$id = $v->id;
			if ($check == $id)
				continue;
			$check = $id;
			
			if (isset($v->snippet->thumbnails->medium->url))
				$img = str_replace("https", "http", $v->snippet->thumbnails->medium->url);
			
			if (isset($v->snippet->localized->title))
				$name = HD::str_remove_tag($v->snippet->localized->title);
			else
				$name = HD::str_remove_tag($v->snippet->title);
			
			$movie = new ShortMovie(
				strval($id),
				strval($name),
				strval($img)
			);
			if (isset($v->id->kind))
				$movie->kind = $v->id->kind;
			else if (isset($v->snippet->resourceId->kind))
				$movie->kind = $v->snippet->resourceId->kind;
			else if (isset($v->kind))
				$movie->kind = $v->kind;
			
			
			$info .= '||' . str_replace("|", "", $name);
			
			$pr = '['. str_replace("youtube#", "", $movie->kind) . '] ';
			if (isset($v->snippet->type))
				$pr = '['. $v->snippet->type . '] ';
			if ((isset($v->snippet->liveBroadcastContent))&&($v->snippet->liveBroadcastContent == "live"))
				$pr .= "[live] ";
			
			if (isset($v->snippet->publishedAt)){
				$date = new DateTime($v->snippet->publishedAt);
				$info .= '|' .$pr. $date->format('d.m.Y H:i');
			}else
				$info .= '|' .$pr;
			if ($movie->kind != "youtube#channel")
				$info .= '||' . $v->snippet->channelTitle;
			if (isset($v->snippet->localized->description))
				$info .= '|' . $v->snippet->localized->description;
			else
				$info .= '|' . $v->snippet->description;
			$movie->info = $info;
			
			if ($arg == true)
				$movie->url = $arg;
			if (isset($v->snippet->channelId))
				$movie->channelId = $v->snippet->channelId;
			if (isset($v->snippet->channelTitle))
				$movie->channelTitle = HD::str_remove_tag($v->snippet->channelTitle);	
			if ((isset($baned_ah[$id]))||((isset($v->snippet->channelId))&&(isset($baned_ah[$v->snippet->channelId]))))
				continue;
			array_push ($items, $movie);
		}
		
		return $items;
	}
	public static function get_group_name($gid) {
		$group_names = array();
    	$group_names = self::get_group();
		$gid = array_key_exists($gid, $group_names) ? $gid : 0;    
		return array($gid, $group_names[$gid]);
    }
		
	public static function getSearchList($keyword, $category, &$m_feed) {
		if ($m_feed === '_end_')
			return array();
		$sort_page_settings = HD::get_items('sort_page_settings');
		$sort = isset($sort_page_settings['search'][$category]['sorting']) ? $sort_page_settings['search'][$category]['sorting'] : '&order=relevance';
		$ylb_api_key = Youtube::get_ylb_api_key();
		$regionCode = isset($sort_page_settings['search'][$category]['regionCode']) ? $sort_page_settings['search'][$category]['regionCode'] : "&regionCode=" . $ylb_api_key['cr'];
		if ($regionCode == '0')
			$regionCode = "&regionCode=" . $ylb_api_key['cr'];
		$relevanceLanguage = isset($sort_page_settings['search'][$category]['relevanceLanguage']) ? $sort_page_settings['search'][$category]['relevanceLanguage'] : "&relevanceLanguage=" .  $ylb_api_key['hl'];
		if ($relevanceLanguage == '0')
			$relevanceLanguage = "&relevanceLanguage=" .  $ylb_api_key['hl'];
		if ($category =='all')
			$url = API_URL . "/search?part=snippet&q=" . urlencode($keyword) . "&type=video,channel,playlist&maxResults=50$sort$regionCode$relevanceLanguage&key=".API_KEY;
		else
			$url = API_URL . "/search?part=snippet&q=" . urlencode($keyword) . "&type=$category&maxResults=50$sort$regionCode$relevanceLanguage&key=".API_KEY;
		if ($m_feed != '0')
			$url = $url . "&pageToken=" . $m_feed;
		$jsd =json_decode (HD::http_get_document($url));
		if (isset($jsd->nextPageToken))
			$m_feed = $jsd->nextPageToken;
		else
			$m_feed = '_end_';
		return self::do_shortmovie($jsd->items, $url);
	}
		
	public static function parse_video_page($video_id, $caption, $poster_url, $url, $plugin_cookies){
		$show_coment = isset($plugin_cookies->show_coment) ? $plugin_cookies->show_coment : 0;
		
		$images = array(); $urls = false;
		$jsd = json_decode(HD::http_get_document(API_URL."/videos?id=$video_id&key=".API_KEY."&part=snippet,contentDetails,statistics,status"));
		if (isset($jsd->items[0]->snippet->thumbnails->standard->url))
			$poster_url = str_replace("https", "http", $jsd->items[0]->snippet->thumbnails->standard->url);	
		$images[] = $poster_url;
		$date = new DateTime($jsd->items[0]->snippet->publishedAt);
		$rate_details ['Time:'] = str_replace(array ("PT","M","S","H"), array ("",":","",":"), $jsd->items['0']->contentDetails->duration);
		$rate_details ['View:'] = $jsd->items[0]->statistics->viewCount;
		$rate_details ['Like:'] = $jsd->items[0]->statistics->likeCount;
		$rate_details ['Dislike:'] = $jsd->items[0]->statistics->dislikeCount;
		if (isset($jsd->items[0]->statistics->commentCount))
			$rate_details ['Сomment:'] =  intval($jsd->items[0]->statistics->commentCount);
		$rate_details ['Favorite:'] = $jsd->items[0]->statistics->favoriteCount;
		$urls['video_url'] = $url;
		$urls['video_id'] = $video_id;

		if ((isset($jsd->items[0]->snippet->tags))&&(count($jsd->items[0]->snippet->tags) > 0))
			$details['Tags:'] = implode(", ", $jsd->items[0]->snippet->tags);
		else
			$details = array();
			
		if ((isset($jsd->items[0]->statistics->commentCount))&&(intval($jsd->items[0]->statistics->commentCount) > 0)&&($show_coment == 1)){
			$urls['comments_url'] = API_URL."/commentThreads?part=snippet%2Creplies&maxResults=100&order=time&videoId=$video_id&key=".API_KEY;
			$jsdo =json_decode (HD::http_get_document($urls['comments_url']));
			$details["======"] = '=================================';
			foreach ($jsdo->items as $k => $v){
				$dates = new DateTime($v->snippet->topLevelComment->snippet->publishedAt);
				$details[$k+1] = "[".$v->snippet->topLevelComment->snippet->authorDisplayName."][Like: ".$v->snippet->topLevelComment->snippet->likeCount."][".$dates->format('d.m.Y H:i')."]". "\n"
				. wordwrap(HD::str_remove_tag($v->snippet->topLevelComment->snippet->textDisplay), 75, "\n");
			}
		}
			
		$urls['user_channels'] = $jsd->items[0]->snippet->channelId;
		$jsdo =json_decode (HD::http_get_document(API_URL."/channels?part=snippet&id=".$jsd->items[0]->snippet->channelId."&key=".API_KEY));
	
		$movie = new Movie($video_id);
		$movie->set_data(
            HD::str_remove_tag($jsd->items[0]->snippet->localized->title),
            HD::str_remove_tag($jsd->items[0]->snippet->channelTitle),
			HD::str_remove_tag($jsd->items[0]->snippet->localized->description),
            str_replace("https", "http", $jsdo->items[0]->snippet->thumbnails->high->url),
            strtoupper($jsd->items[0]->contentDetails->definition),
            $date->format('d.m.Y H:i'),
			$rate_details,
			$details,
			$images,
			$urls
		);
		$movie->add_series_data(
			$video_id,
			HD::str_remove_tag($jsd->items[0]->snippet->localized->title),
			$poster_url,
			$video_id,
			false);
		return $movie;
	}
		
	public static function parse_film_review($VideoId, $item){
		static $arr = false;
		if ($item == 0){
			$arr = false;
			$jsd = json_decode(HD::http_get_document(API_URL."/commentThreads?part=snippet&maxResults=100&order=time&videoId=$VideoId&key=".API_KEY));
			foreach ($jsd->items as $k => $v)
				$arr[$k] = $v->snippet->topLevelComment->snippet;
			if (isset($jsd->nextPageToken))
				$arr['next'] = $jsd->nextPageToken;
			else
				$arr['next'] = false;
		}else if (($item/99-round($item/99)==0)&&($arr['next']== true)){
			$jsd = json_decode(HD::http_get_document(API_URL."/commentThreads?part=snippet&maxResults=100&order=time&videoId=$VideoId&key=".API_KEY. "&pageToken=" . $arr['next']));
			foreach ($jsd->items as $k => $v)
				$arr[] = $v->snippet->topLevelComment->snippet;
			if (isset($jsd->nextPageToken))
				$arr['next'] = $jsd->nextPageToken;
			else
				$arr['next'] = false;
		}
		if (isset($arr[$item])){
			return $arr[$item];
		}else
			return false;
	}
	
	public static function do_get_ylb_api(
		$type, 
		$browseId=null, 
		$continuation=null, 
		$playlistId=null, 
		$query= null, 
		$videoId= null, 
		$playlistIndex = null, 
		$params = null, 
		$target = null, 
		$channelIds = null,
		$noLogIn = null
	){
		$ylb_api_key = Youtube::get_ylb_api_key();		
		$arr["context"]["client"]["clientName"] = "TVHTML5";
		$arr["context"]["client"]["clientVersion"] = "5.20160406";
		$arr["context"]["client"]["screenWidthPoints"] = 1536;
		$arr["context"]["client"]["screenHeightPoints"] = 729;
		$arr["context"]["client"]["screenPixelDensity"] = 1;
		$arr["context"]["client"]["theme"] = "CLASSIC";
		$arr["context"]["client"]["webpSupport"] = false;
		$arr["context"]["client"]["acceptRegion"] =  $ylb_api_key['cr'];
		$arr["context"]["client"]["acceptLanguage"] = $ylb_api_key['hl'];
		$arr["context"]["user"]["enableSafetyMode"] = false;
		if ( $continuation==true)
			$arr["continuation"] = $continuation;
		if ( $browseId==true)
			$arr["browseId"] = $browseId;
		if ( $params==true)
			$arr["params"] = $params;
		if ( $playlistId==true)
			$arr["playlistId"] = $playlistId;
		if ( $playlistIndex==true)
			$arr["playlistIndex"] = $playlistIndex;
		if ( $query==true)
			$arr["query"] = $query;
		if ( $videoId==true)
			$arr["videoId"] = $videoId;
		if ( $target==true)
			$arr['target']["videoId"] = $target;
		if ( $channelIds==true)
			$arr["channelIds"] = $channelIds;
		$otps[CURLOPT_POSTFIELDS] = json_encode ($arr);
		if ($noLogIn == true)
			$jsd = self::http_get_ytb("https://www.googleapis.com/youtubei/v1/$type?key=". $ylb_api_key['api_key'], $otps, $noLogIn);
		else
			$jsd = self::http_get_ytb("https://www.googleapis.com/youtubei/v1/$type?key=". $ylb_api_key['api_key'], $otps);
		if ((isset($jsd->error->errors[0]->reason))&&($jsd->error->errors[0]->reason == 'authError'))
			hd_print('wtf key?!');
		return $jsd;
	}
	public static function current_url($current_url=null){
		static $mUrl = null;
		if ($current_url== true)
			$mUrl = $current_url;
		else
			return $mUrl;
	}
	public static function get_videoId_arr($videoId=null, $ch=null, $likeStatus=null, $subscriptionStatus=null){
		static $videoId_arr = null;
		if ($videoId == ''){
			$videoId_arr = array();
			return false;
		}
		if ($likeStatus==true){
			$videoId_arr[$videoId]['likeStatus'] = str_replace("REMOVELIKE", "INDIFFERENT", $likeStatus);
			return;
		}
		if ($subscriptionStatus==true){
			$videoId_arr[$videoId]['subscribed'] = str_replace(array("subscribe", "unsubscribe",),array(1,''), $subscriptionStatus);
			return;
		}
		if (count($videoId_arr) > 10)
			$videoId_arr = array();
		if ((is_null($videoId_arr))||(!isset($videoId_arr[$videoId]))){
			$jsd = self::do_get_ylb_api('next', null, null, null, null, $videoId);
			foreach ($jsd->contents->singleColumnWatchNextResults->pivot->pivot->contents as $k => $v){
				if (isset($v->pivotShelfRenderer)){
					$title = '';
					if ($ch == true){
						if (isset($jsd->contents->singleColumnWatchNextResults->results->results->contents[1]->itemSectionRenderer->contents[0]->videoOwnerRenderer)){
							$obj = $jsd->contents->singleColumnWatchNextResults->results->results->contents[1]->itemSectionRenderer->contents[0]->videoOwnerRenderer;
							if (isset($obj->title->runs[0]->text))
								$arr['channel']['title'] = $obj->title->runs[0]->text;
							if (isset($obj->navigationEndpoint->browseEndpoint->browseId))
								$arr['channel']['channelId'] = $obj->navigationEndpoint->browseEndpoint->browseId;
						}
					}
					foreach ($v->pivotShelfRenderer->title->runs as $vel)
						$title .= $vel->text;
					if (isset($v->pivotShelfRenderer->shelfIdentifier))
						$arr[$title]['shelfIdentifier'] = ($v->pivotShelfRenderer->shelfIdentifier);
					if (isset($v->pivotShelfRenderer->content->pivotHorizontalListRenderer->items))
						foreach ($v->pivotShelfRenderer->content->pivotHorizontalListRenderer->items as $v){
							if (isset($v->pivotVideoRenderer))
								$v = $v->pivotVideoRenderer;
							if (isset($v->pivotRadioRenderer))
								$v = $v->pivotRadioRenderer;
							if (isset($v->pivotPlaylistRenderer))
								$v = $v->pivotPlaylistRenderer;
							if (isset($v->videoId))
								$arr[$title][$v->videoId]['videoId'] = $id = $v->videoId;
							else if (isset($v->playlistId))
								$arr[$title][$v->playlistId]['playlistId'] = $id = $v->playlistId;
							if (isset($v->thumbnail->thumbnails[1]->url))
								$arr[$title][$id]['thumbnail'] = 'http:' . $v->thumbnail->thumbnails[1]->url;
							if (isset($v->thumbnailRenderer->playlistCustomThumbnailRenderer->thumbnail->thumbnails[1]->url))
								$arr[$title][$id]['thumbnail'] = DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . urlencode ($v->thumbnailRenderer->playlistCustomThumbnailRenderer->thumbnail->thumbnails[0]->url);
							if (isset($v->thumbnailRenderer->playlistVideoThumbnailRenderer->thumbnail->thumbnails[1]->url))
								$arr[$title][$id]['thumbnail'] = 'http:' . $v->thumbnailRenderer->playlistVideoThumbnailRenderer->thumbnail->thumbnails[1]->url;
							if (isset($v->title->runs[0]->text))
								$arr[$title][$id]['title'] = $v->title->runs[0]->text;
							if (isset($v->viewCountText->runs[0]->text))
								$arr[$title][$id]['viewCountText'] = $v->viewCountText->runs[0]->text;
							if (isset($v->lengthText->runs[0]->text))
								$arr[$title][$id]['lengthText'] = $v->lengthText->runs[0]->text;
							if (isset($v->shortBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId))
								$arr[$title][$id]['channelId'] = $v->shortBylineText->runs[0]->navigationEndpoint->browseEndpoint->browseId;
							if (isset($v->shortBylineText->runs[0]->text))
								$arr[$title][$id]['channelTitle'] = $v->shortBylineText->runs[0]->text;
							if (isset($v->publishedTimeText->runs[0]->text))
								$arr[$title][$id]['publishedTimeText'] = $v->publishedTimeText->runs[0]->text;
							if (isset($v->badges[0]->textBadge->label->runs[0]->text))
								$arr[$title][$id]['badges'] = $v->badges[0]->textBadge->label->runs[0]->text;
						}
				}
				if($jsd->responseContext->serviceTrackingParams[0]->params[3]->value == 1){
					$arr['likeStatus'] = $jsd->contents->singleColumnWatchNextResults->results->results->contents[0]->itemSectionRenderer->contents[0]->videoMetadataRenderer->likeStatus;
					$arr['subscribed'] = $jsd->contents->singleColumnWatchNextResults->results->results->contents[1]->itemSectionRenderer->contents[0]->videoOwnerRenderer->subscribeButton->subscribeButtonRenderer->subscribed;
				}
			}
			$videoId_arr[$videoId] = $arr;
		}
		return $videoId_arr[$videoId];
	}
	
	public static function get_relatedPlaylists(){
		$jsd = self::http_get_api_v3('/channels?part=snippet%2CcontentDetails%2Cstatistics&maxResults=50&mine=true');
			$accountPhoto = $jsd->items[0]->snippet->thumbnails->high->url;
			$name = $jsd->items[0]->snippet->localized->title;
			if (isset($jsd->items[0]->contentDetails->relatedPlaylists))
				return $jsd->items[0]->contentDetails->relatedPlaylists;
	}
	public static function get_subscribed_inf($chId){
		$jsd = self::do_get_ylb_api('browse', $chId);
		return $jsd->header->tvChannelHeaderRenderer->subscribeButton->subscribeButtonRenderer->subscribed;
	}
	public static function http_get_api_v3($url, $post = null){
		$tokens = self::get_tokens();
		$ylb_api_key = Youtube::get_ylb_api_key();
		$header = array (
			"Authorization: ".$tokens['token_type']." ".$tokens['access_token']
		);
		
		if ($post==true){
			if ($post == 'delete')
				$otps[CURLOPT_CUSTOMREQUEST] = "DELETE";
			else{
				$otps[CURLOPT_POST] 		= true;
				$otps[CURLOPT_POSTFIELDS]	= $post;
				$header[] = "Content-Type: application/json";
			}
		}
		$otps[CURLOPT_HTTPHEADER] = $header;
		$jsd = json_decode(HD::http_get_document(API_URL . "$url&key=". $ylb_api_key['api_key'], $otps));
		if (((isset($jsd->error->code))&&($jsd->error->code == '401'))&&(isset($tokens['access_token']))){
			$jsds = json_decode(HD::http_post_document('https://www.youtube.com/o/oauth2/token', "client_id=".$ylb_api_key['client_id']."&client_secret=".$ylb_api_key['client_secret']."&refresh_token=".$tokens['refresh_token']."&grant_type=refresh_token"));
			if (isset($jsds->access_token)){
				$tokens['access_token'] = $jsds->access_token;
				self::get_tokens(false, $tokens);
				$header = array (
					"Authorization: ".$tokens['token_type']." ".$tokens['access_token']
				);
				$otps[CURLOPT_HTTPHEADER] = $header;
				$jsd = json_decode(HD::http_get_document(API_URL . "$url&key=". $ylb_api_key['api_key'], $otps));
			}
		}
		return $jsd;
	}
	
	public static function get_tokens($insUname = null, $saveArr = null, $getUname = null){
		static $uname = 'default';
		if (($getUname == true)&&($getUname == 2))
			return str_replace('default', "", $uname);
		if (($insUname == false)&&($saveArr == false)&&($getUname == false)){
			if ($uname == 'default')
				return HD::get_items('tokens');
			else{
				$user_plus_tokens = HD::get_items('user_plus_tokens');
				return $user_plus_tokens[$uname];
			}
		}
		if ($insUname == true){
			$uname = $insUname;
			return true;
		}
		if ($getUname == true){
			if ($uname == 'default')
				return '';
			else
				return ' ('.$uname .')';
		}
		if ($saveArr == true){
			if ($uname == 'default')
				HD::save_items('tokens', $saveArr);
			else{
				$user_plus_tokens = HD::get_items('user_plus_tokens');
				$user_plus_tokens[$uname] = $saveArr;
				HD::save_items('user_plus_tokens', $user_plus_tokens);
			}
			return true;
		}
	}
	
	public static function http_get_ytb($url, $otps = null, $noLogIn = null){
        $tokens = self::get_tokens();
		$ylb_api_key = Youtube::get_ylb_api_key();	
		$header = array (
			"Content-Type: application/json",
			"Origin:https://www.youtube.com",
			"Referer:https://www.youtube.com/tv",
			"User-Agent:Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/54.0.2840.99 Safari/537.36 OPR/41.0.2353.69",
			"X-Goog-Visitor-Id:". $ylb_api_key['visitor_data']);
		if ((isset($tokens['access_token']))&&($noLogIn == false)){
			$header = array (
			"Content-Type: application/json",
			"Origin:https://www.youtube.com",
			"Referer:https://www.youtube.com/tv",
			"User-Agent:Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/54.0.2840.99 Safari/537.36 OPR/41.0.2353.69",
			"X-Goog-Visitor-Id:". $ylb_api_key['visitor_data'],
			"Authorization: ".$tokens['token_type']." ".$tokens['access_token']
			);
		}
		$otps[CURLOPT_HTTPHEADER] = $header;
		$jsd = json_decode(HD::http_get_document($url, $otps));
		if (((isset($jsd->error->code))&&($jsd->error->code == '401'))&&(isset($tokens['access_token']))){
			$jsds = json_decode(HD::http_post_document('https://www.youtube.com/o/oauth2/token', "client_id=".$ylb_api_key['client_id']."&client_secret=".$ylb_api_key['client_secret']."&refresh_token=".$tokens['refresh_token']."&grant_type=refresh_token"));
			if (isset($jsds->access_token)){
				$tokens['access_token'] = $jsds->access_token;
				self::get_tokens(false, $tokens);
				$otps[CURLOPT_HTTPHEADER] = array (
					"Content-Type: application/json",
					"Origin:https://www.youtube.com",
					"Referer:https://www.youtube.com/tv",
					"User-Agent:Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/54.0.2840.99 Safari/537.36 OPR/41.0.2353.69",
					"X-Goog-Visitor-Id:". $ylb_api_key['visitor_data'],
					"Authorization: ".$tokens['token_type']." ".$jsds->access_token
				);
				$jsd = json_decode(HD::http_get_document($url, $otps));
			}
		}
		return $jsd;
    }
}
?>
