﻿<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/user_input_handler_registry.php';
class SmartEntryHandler
    implements UserInputHandler
{
    private $vod;

    public function __construct($vod){
        $this->vod = $vod;
        UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    public function get_handler_id(){
        return 'entry';
    }
	
    public function handle_user_input(&$user_input, &$plugin_cookies){
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		if ((isset($user_input->control_id))&&($user_input->control_id == 'save_yes')){
			$plugin_cookies->disclaimer = 'yes';
			return ActionFactory::open_folder();
		}
		if ((isset($user_input->control_id))&&($user_input->control_id == 'do_hard_reset'))
			return shell_exec('reboot');
		if ((isset($user_input->control_id))&&($user_input->control_id == 'do_setup'))
			return ActionFactory::open_folder(SmartSetupScreen::get_media_url_str(),'%tr%t1');
		if ((isset($user_input->control_id))&&($user_input->control_id == 'power_off'))
			return shell_exec('echo A15EBF00 > /proc/ir/button');
		if ($user_input->handler_id == 'entry')
			return ActionFactory::open_folder();
    }
}

///////////////////////////////////////////////////////////////////////////
?>
